# electron-builder

You decided to contribute to this project? Great, thanks a lot for pushing it.

Before you file an issue or make a pull request please check these points:

## Needed issue information

When filing an issue please make sure, that you give all information needed.

This includes:

- description of what you're trying to do
- package.json
- config.json
- log of the terminal output
- node version
- npm version
- on which system do you want to create installers (Win/MacOS,Linux)

## Pull requests notes

### Editor settings
- please set up your editor to use two spaces
- remove spaces at line endings or empty lines
- make sure all files end with one empty line

### Coding style

#### I really like spaces, because I think they improve the readability a lot. Please try to keep that in mind.

To check that your contributions match the given coding style make sure `npm test` passes.
We use [ESLint](http://eslint.org/) to guarantee a consistent coding style.

#### Please try to stick to line max character number of 80.

I know that it is sometimes unavoidable to go over it. But function arguments and long if-conditions can include line breaks. ;)

#### Please don't forget to add JSDoc to every new implemented function.
